// Sakura-EditorpvOC
// {}I[gCfg ver 1.2
// copyright 2010-2012 Moca
var ch = Indent.GetChar();
if( ch == "\r" || ch == "}" /* || ch == ")" */){
	CppIndent(ch);
}

function CppIndent(ch)
{
	var nCurColm = parseInt(Editor.ExpandParameter("$x"), 10);
	var nCurLine   = parseInt(Editor.ExpandParameter("$y"), 10);
	var strLine = Editor.GetLineStr(nCurLine);
	var strLineIndent = strLine.match(/^[ \t@]*/)[0];
	var nBaseLine = 1;
	var strBaseLine = "";
	var strBaseIndent = "";
	var baseDataLen = 0;
	var i;
	// 󔒍s΍ŏɂ̂ڂ
	for( i = 1; 0 == baseDataLen && i < 3 && 1 <= nCurLine - i; ++i ){
		nBaseLine     = nCurLine - i;
		strBaseLine   = Editor.GetLineStr(nBaseLine);
		strBaseIndent = strBaseLine.match(/^[ \t@]*/)[0];
		baseDataLen   = strBaseLine.length - strBaseLine.match(/[\r\n]*$/)[0].length;
	}
	var nIndentDiff = GetIndentDiff(strBaseLine);
	//^u
	var nTabWidth = Editor.ChangeTabWidth( 0 );
	if( nTabWidth <= 0 ){
		nTabWidth = 1;
	}
	var Opt_IndentMode = Plugin.GetOption("Option", "IndentMode");
	var Opt_IndentWidth = Plugin.GetOption("Option", "IndentWidth");
	var nIndentMode  = (Opt_IndentMode == "" ? 0 : parseInt(Opt_IndentMode, 10));
	var nIndentWidth = parseInt(Opt_IndentWidth, 10);
	if( nIndentWidth <= 0 ){
		Plugin.SetOption("Option", "IndentWidth", nTabWidth);
		nIndentWidth = nTabWidth;
	}
	// ݒ""0
	// Cfgu
	var nIndentPrevData = (Plugin.GetOption("Option", "IndentPrevData") == "1" ? 1 : 0);
	// tCfgFftHgON
	var nIndentUnindent = (Plugin.GetOption("Option", "IndentUnindent") != "0" ? 1 : 0);
	// s̓r̉s
	var nIndentMiddle = (Plugin.GetOption("Option", "IndentMiddleLineBreak"));
		nIndentMiddle = (nIndentMiddle == "" ? 1 : parseInt(nIndentMiddle, 10));
	var newIndent;

	var strIns = "";
	if( "\r" == ch ){
		var bMiddle = false;
		if( 1 != nIndentMiddle ){
			bMiddle = (strLineIndent.length < strLine.length &&
				strLineIndent.length < (strLine.length - strLine.match(/[\r\n]*$/)[0].length));
		}
		if( bMiddle ){
			if( 0 == nIndentMiddle ){
				return;
			}
			if( 1 == nIndentMiddle ){
			}
			if( 2 == nIndentMiddle ){
				if( nIndentDiff < 1 ){
					nIndentDiff = 1;
				}
			}
		}
		// Cfg
		if( 0 === nIndentMode ){
		    // ^uCfg
			if( 1 <= nIndentDiff ){
				strIns = "\t";
			}
			if( 1 === nIndentPrevData ){
				// Xy[X^uϊ
				newIndent = Tab2Sp(strBaseIndent, nTabWidth) + strIns;
				newIndent = newIndent.replace(new RegExp(Tab2Sp("\t", nTabWidth), "g"), "\t");
				ReplaceLine(strLine, strLineIndent, newIndent, true);
			}else{
				newIndent = strBaseIndent + strIns;
				ReplaceLine(strLine, strLineIndent, newIndent, true);
			}
		}else if( 1 == nIndentMode ){
			// Xy[XCfg
			if( 1 <= nIndentDiff ){
				for( i = 0; i < nIndentWidth; i++ ){
					strIns += " ";
				}
			}
			if( 1 == nIndentPrevData ){
				newIndent = Tab2Sp(strBaseIndent, nTabWidth) + strIns;
				ReplaceLine(strLine, strLineIndent, newIndent, true);
			}else{
				ReplaceLine(strLine, strLineIndent, strBaseIndent + strIns, true);
			}
		}else{
			// Tab+Xy[XCfg
			if( 1 <= nIndentDiff ){
				for( i = 0; i < nIndentWidth; i++ ){
					strIns += " ";
				}
			}
			newIndent = Tab2Sp(strBaseIndent, nTabWidth) + strIns;
			newIndent = newIndent.replace(new RegExp(Tab2Sp("\t", nTabWidth), "g"), "\t");
			ReplaceLine(strLine, strLineIndent, newIndent, true);
		}
	}else if( 0 != nIndentUnindent && (ch == /*{*/"}" || ch == /*(*/")") ){
		// [Cfg] ̂Ƃu
		var last1 = strLine.substr(strLineIndent.length, 1);
		var last2 = strLine.substr(strLineIndent.length, 2); //((
		if( last1 == /*{*/"}" || last1 == ")" || last2 == "){"/*}*/ ){
			// tCfg
			var nTempWidth = Tab2Sp(strBaseIndent, nTabWidth).length;
			var nNewWidth = nTempWidth - nIndentWidth;
			if( 0 < nIndentDiff ){
				nNewWidth += nIndentDiff * nIndentWidth;
			}
			if( nNewWidth < 0 ){ nNewWidth = 0; }
			newIndent = strBaseIndent;
			for( i = strBaseIndent.length; 0 <= i; --i ){
				newIndent = strBaseIndent.substr(0,i);
				nTempWidth = Tab2Sp(newIndent, nTabWidth).length;
				if( nTempWidth <= nNewWidth ){
					break;
				}
			}
			for( i = nTempWidth; i < nNewWidth; i++ ){
				newIndent += " ";
			}
			ReplaceLine(strLine, strLineIndent, newIndent, false);
		}
	}
}

function Tab2Sp(str, width)
{
	var ret = "";
	var nexti = 0;
	var tabadd = 0;
	var i;
	for( i = 0; i < str.length; i++ ){
		if( 0x09 == str.charCodeAt(i) ){
			ret += str.substring(nexti, i);
			nexti = i + 1;
			var add = width - ((i + tabadd) % width);
			tabadd += add - 1;
			for( var t = 0; t < add; t++ ){
				ret += " ";
			}
		}else if( 0x3000 == str.charCodeAt(i) ){
			ret += str.substring(nexti, i);
			nexti = i + 1;
			tabadd++;
			ret += "  ";
		}
	}
	if( i < str.length ){
		ret += str.substring(nexti, i);
	}
	return ret;
}

function ReplaceLine(line, org, repData, ins)
{
	if( org != repData ){
		if( ins && org.length < repData.length && org == repData.substr(0, org.length) ){
			Editor.InsText(repData.substr(org.length));
		}else{
			Editor.SelectLine(0);
			var selLine = Editor.GetSelectedString(0);
			var lastChar;
			if( 1 < selLine.length ){
				lastChar = selLine.charCodeAt(selLine.length-1);
			}else{
				lastChar = -1;
			}
			Editor.InsText( line.replace(org, repData) ); // Replace
			if( lastChar == 0x0a || lastChar == 0x0d ){
				Editor.Left(0);
			}
		}
	}
}

// @{}E߂̍s͊
// return Cfg
function GetIndentDiff(strLine)
{
	var rePerseItems = /[\/\'\"\{\}\(\)]|(@")/; // ' //"
	var nLinePos = 0;
	var strLineSub = strLine;
	var nLineEnd = strLine.length;
	var nCharCode;
	var nlastBracket = 0;
	var nParentheses = 0
	var nIndent  = 0;
	var nIndent2 = 0;
	var retRe;
	var hoge = 0;

	for( ; nLinePos < nLineEnd; ++nLinePos ){
		if(0 < nLinePos){
			strLineSub = strLine.substr(nLinePos);
		}
		retRe = strLineSub.search(rePerseItems);
		if(-1 == retRe){
			break; // ̍s
		}
		// Editor.TraceOut(hoge + "re:" + retRe + " nLinePos" + (nLinePos + retRe));
		hoge += 1;
		nLinePos += retRe;
		
		nCharCode = strLine.charCodeAt(nLinePos);
		if( 0x2f == nCharCode ){
			// '//'
			if( 0x2f == strLine.charCodeAt(nLinePos + 1) ){
				break;
			}
			// /*
			if( 0x2a == strLine.charCodeAt(nLinePos + 1) ){
				nPos = strLine.substr(nLinePos + 2).indexOf("*/");
				if( -1 == nPos){
					break;
				}
				nLinePos += nPos + 3; //fix:v0.2 4=>3
				continue;
			}
			//RRɂ Z(/,/=)K\(/xxxx/ig)
			// Zq(P-+ȊO)AȂ̂ŁAZq/͐K\
			var strRegexLeft = strLineSub.substr(0,nLinePos + 1 - (nLineEnd - strLineSub.length));
			// O͉Zq ܂͉Ȃ ua + /test/.match(str)[0]vƂ̂...
			// {}[(,:;=<>!+-*/%&^|?    ႤZq .)]'"
			if( -1 != strRegexLeft.search(/[\{\}\[\(\,\:;=<>!\+\-\*\/%\&\^\|\?][ \t@\xa0]*\/$/) || // \]\)
					-1 != strRegexLeft.search(/^[ \t@\xa0]*\/$/)){
				if(null != (retRe = strLine.substr(nLinePos).match(/^\/(?:\\.|[^\/\r\n])+\/[gimy]{0,4}/)) ){
					var strRegexRight = strLine.substr(nLinePos + retRe[0].length);
					// ẺZqmF  Ίʋ܂킹 \( \[
					if( -1 != strRegexRight.search(/^[ \t@\xa0]*([\)\.\]\r\n\{\}\,\:;=<>!\+\-\*\/%\&\^\|\?]|\/\/|\/\*)/) ){
						nLinePos += retRe[0].length - 1;
					} // else @ error
				}
			}
		}else
		// '
		if( 0x27 == nCharCode ){
			++nLinePos;
			for(; nLinePos < nLineEnd; ++nLinePos){
				// \
				if( 0x5c == strLine.charCodeAt(nLinePos) ){
					++nLinePos;
					if( nLinePos < nLineEnd && 
							0x27 == strLine.charCodeAt(nLinePos) ){
						break; // 'I
					}
				}else if( 0x27 == strLine.charCodeAt(nLinePos) ){
					break; // 'I
				}
			}
			continue;
		}else
		// "
		if( 0x22 == nCharCode ){
			++nLinePos;
			for(; nLinePos < nLineEnd; ++nLinePos){
				// \
				if( 0x5c == strLine.charCodeAt(nLinePos) ){
					++nLinePos;
					if( nLinePos < nLineEnd && 
							0x22 == strLine.charCodeAt(nLinePos) ){
						break; // "I
					}
				}else if( 0x22 == strLine.charCodeAt(nLinePos) ){
					break;  // "I
				}
			}
			continue;
		}else
		// @"
		if(0x40 == nCharCode && 0x22 == strLine.charCodeAt(nLinePos + 1)){
			++nLinePos;
			++nLinePos; // "̂Ԃ
			for(; nLinePos < nLineEnd; ++nLinePos){
				// "
				if( 0x22 == strLine.charCodeAt(nLinePos) ){
					break;  // "I
				}
			}
		}else
		// {
		if(0x7b == nCharCode){
			++nIndent;
			nlastBracket = 1;
		}else
		// }
		if(0x7d == nCharCode){
			--nIndent;
			nlastBracket = 2;
		}else
		// (
		if(0x28 == nCharCode){
			++nIndent2;
			nParentheses = 1;
		}else
		// )
		if(0x29 == nCharCode){
			--nIndent2;
			nParentheses = 2;
		}
	}
	var ret = nIndent + nIndent2;
	// {
	// "} else {"n   // }
	if( nlastBracket == 1 && 0 == nIndent  ){
		ret = 1;
	}else
	if( nParentheses == 1 && 0 == nIndent2 ){
		ret = 1;
	}
	return ret;
}
